<?php
/**************** Register Sidebar Widgets *****************/
if ( function_exists('register_sidebar') )
    register_sidebar(array(
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => '</li>',
        'before_title' => '<h2 class="widgettitle">',
        'after_title' => '</h2>',
    ));

/**************** Custom Image Header ****************/
// Reference
$yuiGrids = array("doc"=>750,"doc2"=>950,"doc3"=>1024,"doc4"=>974,"custom-doc"=>(get_option('zl_custom_page_width') == "" ? 750 : intval(get_option('zl_custom_page_width'))));
//  Set some default values
define('HEADER_TEXTCOLOR', 'fff'); //  Default text color
define('HEADER_IMAGE', '%s/images/default.gif'); // %s is theme dir uri, set a default image
define('HEADER_IMAGE_WIDTH', 200); //  Default image width is actually the div's height
define('HEADER_IMAGE_HEIGHT', 45);  // Same for height

function header_style() {
    //  This function defines the style for the theme
    //  You can change these selectors to match your theme
?>
<style type="text/css">
#header{
    background: url(<?php header_image() ?>) no-repeat;
    height: <?php echo HEADER_IMAGE_HEIGHT; ?>px;
    width:<?php echo HEADER_IMAGE_WIDTH; ?>px;
	padding:0 0 0 18px;
}
#header h1 {
    padding-top:10;
    margin: 0;
}
.logo {
    display: none;
}
<?php
//  Has the text been hidden?
//  If so, set display to equal none
if ( 'blank' == get_header_textcolor() ) { ?>
#header h1, #header #desc {
    display: none;
}
.logo {
    display: inline;
}
<?php } else {
    //  Otherwise, set the color to be the user selected one
    ?>
#header h1 a, #desc {
    color:#<?php header_textcolor() ?>;
}
<?php } ?>
</style>
<?php
}
function admin_header_style() {
    //  This function styles the admin page
?>
<style type="text/css">
#headimg{
    background: url(<?php header_image() ?>) no-repeat;
    height: <?php echo HEADER_IMAGE_HEIGHT; ?>px;
    width:<?php echo HEADER_IMAGE_WIDTH; ?>px;
    padding:0 0 0 18px;
}



#headimg h1{
    padding-top:50px;
    margin: 0;
}
#headimg h1 a, #desc{
    color:#<?php header_textcolor() ?>;
    text-decoration: none;
    border-bottom: none;
}
#desc {
    padding-top: 15px;
    margin-right: 30px;
}
<?php if ( 'blank' == get_header_textcolor() ) { ?>
#headimg h1, #headimg #desc {
    display: none;
}
#headimg h1 a, #headimg #desc {
    color:#<?php echo HEADER_TEXTCOLOR ?>;
}
<?php } ?>
</style>
<?php
}
/*  This is the key function call, it communicates with the API
    and adds the options to the admin menu.  You pass the names of your
    two styling functions, first the one that styles the theme, then
    the one that styles the admin page*/
add_custom_image_header('header_style', 'admin_header_style');
/**************** Legacy Comments ****************/
add_filter('comments_template', 'legacy_comments');
function legacy_comments($file) {
	if ( !function_exists('wp_list_comments') ) 
		$file = TEMPLATEPATH . '/legacy.comments.php';
	return $file;
}
/**************** Options Page ****************/
$themename = "Twordder Theme";
$shortname = "tw";
$options = array (
    
    array(  "name" => "Page Width",
            "id" => $shortname."_page_width",
			"type" => "select",
            "std" => "doc",
            "options" => array(
				"doc" => "750px Centered", 
				"doc2"=> "950px Centered", 
				//"doc4"=> "974px Centered", 
				//"doc3"=> "100% Fluid", 
				"custom-doc"=> "Custom Page Width")),
    
    array(    "name" => "Custom Page Width",
            "id" => $shortname."_custom_page_width",
            "std" => "",
            "type" => "text"),
    
    array(    "name" => "Layout Templates",
            "id" => $shortname."_layout_template",
            "type" => "select",
            "std" => "yui-t5",
            "options" => array(
				"yui-t1" => "Two columns, narrow on left, 160px", 
				"yui-t2"=> "Two columns, narrow on left, 180px", 
				"yui-t3"=> "Two columns, narrow on left, 300px", 
				"yui-t4"=> "Two columns, narrow on right, 180px", 
				"yui-t5"=> "Two columns, narrow on right, 240px", 
				"yui-t6"=> "Two columns, narrow on right, 300px")),
				
    array(    "name" => "Background",
            "id" => $shortname."_background",
            "std" => "#ffffff",
            "type" => "ctext"),

    array(    "name" => "Text",
            "id" => $shortname."_text",
            "std" => "#ffffff",
            "type" => "ctext"),
			
    array(    "name" => "Links",
            "id" => $shortname."_links",
            "std" => "#ffffff",
            "type" => "ctext"),
		
    array(    "name" => "Sidebar",
            "id" => $shortname."_sidebar",
            "std" => "#ffffff",
            "type" => "ctext"),
			
    array(    "name" => "Sidebar Border",
            "id" => $shortname."_sidebar_border",
            "std" => "#ffffff",
            "type" => "ctext"),
			
    array(    "name" => "Background Image",
            "id" => $shortname."_background_image",
            "std" => "",
            "type" => "text"),
			
    array(    "name" => "Tile",
            "id" => $shortname."_tile",
            "std" => "",
            "type" => "checkbox"),
);
$tw_options = array();
function tw_add_admin() {

    global $themename, $shortname, $options;
    //zend_debug::dump($_POST);
	

    if ( $_GET['page'] == basename(__FILE__) ) {
    
        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }
				$tile = $_REQUEST['tw_tile'];
				if (empty($tile)){
					update_option('tw_tile', 'false');
				}
                header("Location: themes.php?page=functions.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); }

            header("Location: themes.php?page=functions.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Options", "Current Theme Options", 'edit_themes', basename(__FILE__), 'tw_admin');

}
function tw_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
?>


<div class="wrap">
<h2><?php echo $themename; ?> settings</h2>
<iframe id="preview" name="preview" src="<?php echo get_option('siteurl');  ?>?preview=true" style="width:100%;height:300px;"></iframe>
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.2.6/jquery.min.js"></script>
<script type="text/javascript" src="<?php bloginfo('template_url'); ?>/farbtastic/farbtastic.js"></script>
<link type="text/css" rel="stylesheet" href="<?php bloginfo('template_url'); ?>/farbtastic/farbtastic.css" />
<script type="text/javascript">
  
   $(document).ready(function() {
    var f = $.farbtastic('#colorpicker');
    var p = $('#colorpicker').css('opacity', 0.25);
    var selected;
    $('.picker')
      .each(function () { f.linkTo(this); $(this).css('opacity', 0.75); })
      .focus(function() {
        if (selected) {
          $(selected).css('opacity', 0.75);
        }
        f.linkTo(this);
        p.css('opacity', 1);
        $(selected = this).css('opacity', 1);
      });
  });


function setColors(){
	document.getElementById('tw_background').value = colors[0];
	document.getElementById('tw_text').value = colors[1];
	document.getElementById('tw_links').value = colors[2];
	document.getElementById('tw_sidebar').value = colors[3];
	document.getElementById('tw_sidebar_border').value = colors[4];
	document.getElementById('tw_background').style.backgroundColor = colors[0];
	document.getElementById('tw_text').style.backgroundColor = colors[1];
	document.getElementById('tw_links').style.backgroundColor = colors[2];
	document.getElementById('tw_sidebar').style.backgroundColor = colors[3];
	document.getElementById('tw_sidebar_border').style.backgroundColor = colors[4];
	//set colors
	window.frames['preview'].document.body.style.backgroundColor = colors[0];
	window.frames['preview'].document.backgroundColor = colors[0];
	window.frames['preview'].document.color = colors[1];
	window.frames['preview'].document.body.style.color = colors[1] ;
	window.frames['preview'].document.getElementById('sb').style.backgroundColor = colors[3];
	$("a", window.frames['preview'].document).css({'color' : colors[2], 'text-decoration': 'none'});
    $("html", window.frames['preview'].document).css({'background-color' : colors[0]});
	<?php
		switch(get_option('tw_layout_template')){
		case 'yui-t1':
		case 'yui-t2':
		case 'yui-t3':
			$borderPos = 'right';
		break;
		case 'yui-t4':
		case 'yui-t5':
		case 'yui-t6':
			$borderPos = 'left';
		break;
	}
	?>
	$(".sidebar-wrapper", window.frames['preview'].document).css({'border-<?php echo $borderPos; ?>' : colors[4] + ' 1px solid'});



}
function shuffleColors(){
	colors = shuffle(colors);
	setColors();
}

function shuffle(o){ //v1.0
	for(var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
	return o;
};
var palette = new Object();
var colors = new Array();
colors[0] = '<?php echo get_option('tw_background') ?>';
colors[1] = '<?php echo get_option('tw_text') ?>';
colors[2] = '<?php echo get_option('tw_links') ?>';
colors[3] = '<?php echo get_option('tw_sidebar') ?>';
colors[4] = '<?php echo get_option('tw_sidebar_border') ?>';

function getRandom(){
	colorId = document.getElementById('colorId').value;
    $.getJSON("<?php bloginfo('template_url'); ?>/lib/api-colourlovers.php?id="+ colorId, function(data){
	palette = data;
	colors =palette.colors;  
	document.getElementById('badge').src = palette.badgeurl ;
	document.getElementById('badgeLink').href = palette.url ;
	document.getElementById('colorIdLbl').innerHTML = palette.id ;
	setColors();
});


}

</script>

<input id="colorId" name="colorId" type="text" value=""  /> Enter the <a href="http://www.colourlovers.com">ColourLovers</a> ID or leave it blank to get a random color palette .
<p class="submit">
<input name="getRandom" type="button" value="Get New Colors" onclick="getRandom();" />
<input name="shuffleColors" type="button" value="Shuffle Colors" onclick="shuffleColors();" />   
</p>
<strong><span id="colorIdLbl"></span></strong> <br />
<a id="badgeLink" ><img id="badge"/></a>

<form method="post">

<table class="form-table">

<?php foreach ($options as $value) { 
    
if ($value['type'] == "text") { ?>
        
<tr valign="top"> 
    <th scope="row"><?php echo $value['name']; ?>:</th>
    <td>
        <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" />
    </td>
</tr>

<?php } elseif ($value['type'] == "ctext") { ?>
        
<tr valign="top"> 
    <th scope="row"><?php echo $value['name']; ?>:</th>
    <td>
        <input name="<?php echo $value['id']; ?>" class="picker" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo get_settings( $value['id'] ); } else { echo $value['std']; } ?>" />
    </td>
</tr>

<?php } elseif ($value['type'] == "checkbox") { ?>
        
<tr valign="top"> 
    <th scope="row"><?php echo $value['name']; ?>:</th>
    <td>
        <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="true" <?php if(get_settings( $value['id'] ) == 'true') echo 'checked="yes"'; ?> /> 
    </td>
</tr>

<?php } elseif ($value['type'] == "select") { ?>

    <tr valign="top"> 
        <th scope="row"><?php echo $value['name']; ?>:</th>
        <td>
            <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
                <?php foreach ($value['options'] as $option=>$text) { ?>
                <option value="<?php echo $option; ?>" <?php if ( get_settings( $value['id'] ) == $option && get_settings( $value['id'] )  != "") { echo ' selected="selected"'; } elseif ($option == $value['std'] && get_settings( $value['id'] )  == "") { echo ' selected="selected"'; } ?>><?php echo $text; ?></option>
                <?php } ?>
            </select>
        </td>
    </tr>

<?php 
} 
}
?>

</table>

<div id="colorpicker"></div>
  

<p class="submit">
<input name="save" type="submit" value="Save changes" />    
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>

<script type="text/javascript">
	setTimeout("setColors()",2000)
</script>
<?php
}

function array_to_object($array = array()) {
    if (!empty($array)) {
        $data = false;

        foreach ($array as $akey => $aval) {
            $data -> {$akey} = $aval;
        }

        return $data;
    }

    return false;
}

if(!function_exists('tw_wp_head')){
function tw_wp_head() { 
	?>
	<style type="text/css"> 
	#custom-doc {
		margin:auto;text-align:left; /* leave unchanged */
		width: <?php echo round((get_option('tw_custom_page_width') == "" ? 750 : intval(get_option('tw_custom_page_width')))/13,2); ?>em;/* non-IE */
		*width:<?php echo round((get_option('tw_custom_page_width') == "" ? 750 : intval(get_option('tw_custom_page_width')))/13.3333,2); ?>em;/* IE */
		min-width:<?php echo intval(get_option('tw_custom_page_width')); ?>px;/* optional but recommended */
	}
	</style>
	
	<?php	
	}
}

if(!function_exists('yui_menu_wp_head')){
	function yui_menu_wp_head() { 
	?>
	<link rel="stylesheet" type="text/css" href="http://yui.yahooapis.com/combo?2.6.0/build/menu/assets/menu.css" /> 
	<script type="text/javascript" src="http://yui.yahooapis.com/combo?2.6.0/build/yahoo-dom-event/yahoo-dom-event.js&amp;2.6.0/build/container/container_core-min.js&amp;2.6.0/build/menu/menu-min.js"></script>
	<script type="text/javascript">
	   YAHOO.util.Event.onContentReady("navmenu", function () {
	    var oMenuBar = new YAHOO.widget.MenuBar("navmenu", { 
	                                                    autosubmenudisplay: true, 
	                                                    hidedelay: 750, 
	                                                    lazyload: true });
	        oMenuBar.render();
	    });
	</script>
	<?php	
	}
}

if(!function_exists('tw_wp_foot')){
	function tw_wp_foot(){
		switch(get_option('tw_layout_template')){
			case 'yui-t1':
			case 'yui-t2':
			case 'yui-t3':
				$sidebarPos = 'left';
				$mainPos='right';
			break;
			case 'yui-t4':
			case 'yui-t5':
			case 'yui-t6':
				$sidebarPos = 'right';
				$mainPos='left';
			break;
				
		}
		
?>
<script type="text/javascript" src="<?php bloginfo('template_url'); ?>/js/jquery.corners.min.js"></script>
<script type="text/javascript">
if (YAHOO.env.ua.ie == 0) { 
if (YAHOO.env.ua.opera == 0) {
$webarizejQuery = jQuery.noConflict();

	$webarizejQuery(document).ready( function(){
		$webarizejQuery ('.rounded').corners("5px");
	});
	$webarizejQuery(document).ready( function(){
		$webarizejQuery ('.main-wrapper').corners("<?php echo $mainPos ?> 5px");
	});
	$webarizejQuery (document).ready( function(){
		$webarizejQuery ('.main-wrapper-wide').corners("5px");
	});
	$webarizejQuery (document).ready( function(){
		$webarizejQuery ('.sidebar-wrapper').corners("<?php echo $sidebarPos ?> 5px");
	});
	$webarizejQuery (document).ready( function(){
		$webarizejQuery ('.footer-wrapper').corners(" 5px");
	});
}}

	
YAHOO.util.Event.onDOMReady(function(){yuiFixColHeight();}); 

function yuiFixColHeight() {
     var divs,contDivs,maxHeight,divHeight,d;
     divs=document.getElementsByTagName('div');
     contDivs=[];
     maxHeight=0;
     for(var i=0;i<divs.length;i++){
          if(/\byui-b\b/.test(divs[i].className)){
                d=divs[i];              
                contDivs[contDivs.length]=d;
                if(d.offsetHeight){
                     divHeight=d.offsetHeight;
                }
                else if(d.style.pixelHeight){
                     divHeight=d.style.pixelHeight;
                }
                maxHeight=Math.max(maxHeight,divHeight);
          }
     }

     for(var i=0;i<contDivs.length;i++){
          contDivs[i].style.height=maxHeight+ 'px' ; 
     }
}

</script>
<?php
	}
}

//function tw_init(){
	if(get_option('tw_page_width') == ''){
		update_option('tw_page_width','doc');
	}
	if(get_option('tw_layout_template') == ''){
		update_option('tw_layout_template','yui-t5');
	}
	if(get_option('tw_background') == ''){
		update_option('tw_background','#0099B9');
	}
	if(get_option('tw_text') == ''){
		update_option('tw_text','#3C3940');
	}
	if(get_option('tw_links') == ''){
		update_option('tw_links','#000000');
	}
	if(get_option('tw_sidebar') == ''){
		update_option('tw_sidebar','#95E8EC');
	}
	if(get_option('tw_sidebar_border') == ''){
		update_option('tw_sidebar_border','#5ED4DC');
	}
	if(get_option('tw_tile') == ''){
		update_option('tw_tile','');
	}
//}
add_action('wp_head', 'tw_wp_head');
add_action('wp_footer', 'tw_wp_foot');
add_action('wp_head', 'yui_menu_wp_head');
add_action('admin_menu', 'tw_add_admin'); 


/**************** YUI Menu code ****************/
if(!function_exists('yui_wp_list_pages')){
	function yui_wp_list_pages($args = '') {
		$defaults = array(
			'depth' => 0, 'show_date' => '',
			'date_format' => get_option('date_format'),
			'child_of' => 0, 'exclude' => '',
			'title_li' => __('Pages'), 'echo' => 1,
			'authors' => '', 'sort_column' => 'menu_order, post_title',
			'link_before' => '', 'link_after' => ''
		);
	
		$r = wp_parse_args( $args, $defaults );
		extract( $r, EXTR_SKIP );
	
		$output = '<div  id="navmenu" class="yuimenubar yuimenubarnav"><div class="bd"><ul class="first-of-type">';
		$current_page = 0;
	
		// sanitize, mostly to keep spaces out
		$r['exclude'] = preg_replace('[^0-9,]', '', $r['exclude']);
	
		// Allow plugins to filter an array of excluded pages
		$r['exclude'] = implode(',', apply_filters('wp_list_pages_excludes', explode(',', $r['exclude'])));
	
		// Query pages.
		$r['hierarchical'] = 0;
		$pages = get_pages($r);
	
		if ( !empty($pages) ) {
			if ( $r['title_li'] )
				$output .= '<li class="pagenav yuimenuitem">' . $r['title_li'] . ' <div class="yuimenu"><div class="bd"><ul>';
	
			global $wp_query;
			if ( is_page() || $wp_query->is_posts_page )
				$current_page = $wp_query->get_queried_object_id();
			$output .= yui_walk_page_tree($pages, $r['depth'], $current_page, $r);
			if ( $r['title_li'] )
				$output .= '</ul></div></div></li>';
		}
	    $output .= '</ul></div></div>';
		$output = apply_filters('wp_list_pages', $output);
	
		if ( $r['echo'] )
			echo $output ;
		else
			return $output;
	}
}

if(!function_exists('yui_walk_page_tree')){
	function yui_walk_page_tree($pages, $depth, $current_page, $r) {
		$walker = new yui_Walker_Page;
		$args = array($pages, $depth, $r, $current_page);
		return call_user_func_array(array(&$walker, 'walk'), $args);
	}
}

if(!class_exists('yui_Walker_Page')){
	class yui_Walker_Page extends Walker {
	
		var $tree_type = 'page';
	
	
		var $db_fields = array ('parent' => 'post_parent', 'id' => 'ID');
	
		function start_lvl(&$output, $depth) {
			$indent = str_repeat("\t", $depth);
			$output .= "\n$indent<div class=\"yuimenu\"><div class=\"bd\"><ul class=\"first-of-type\">\n";
		}
	
	
		function end_lvl(&$output, $depth) {
			$indent = str_repeat("\t", $depth);
			$output .= "$indent</ul></div></div>\n";
		}
	
	
		function start_el(&$output, $page, $depth, $args, $current_page) {
			if ( $depth )
				$indent = str_repeat("\t", $depth);
			else
				$indent = '';
	
			extract($args, EXTR_SKIP);
			$css_class = 'page_item page-item-'.$page->ID;
			if ( !empty($current_page) ) {
				$_current_page = get_page( $current_page );
				if ( isset($_current_page->ancestors) && in_array($page->ID, (array) $_current_page->ancestors) )
					$css_class .= ' current_page_ancestor';
				if ( $page->ID == $current_page )
					$css_class .= ' current_page_item';
				elseif ( $_current_page && $page->ID == $_current_page->post_parent )
					$css_class .= ' current_page_parent';
			} elseif ( $page->ID == get_option('page_for_posts') ) {
				$css_class .= ' current_page_parent';
			}
	
			$output .= $indent . '<li class="yuimenuitem ' . $css_class . '"><a class="yuimenuitemlabel" href="' . get_page_link($page->ID) . '" title="' . attribute_escape(apply_filters('the_title', $page->post_title)) . '">' . $link_before . apply_filters('the_title', $page->post_title) . $link_after . '</a>';
	
			if ( !empty($show_date) ) {
				if ( 'modified' == $show_date )
					$time = $page->post_modified;
				else
					$time = $page->post_date;
	
				$output .= " " . mysql2date($date_format, $time);
			}
		}
	
		function end_el(&$output, $page, $depth) {
			$output .= "</li>\n";
		}
	
	}
}

/****************** Comments *****************************/

function twordder_comment($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?>
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
     <div id="comment-<?php comment_ID(); ?>" class="comment-u">
<div class="yui-gf"> 
	<div class="yui-u first">
          <?php echo get_avatar($comment,$size='50',$default='<path_to_url>' ); ?>
		<br />
		<?php printf(__('<cite class="fn">%s</cite>'), get_comment_author_link()) ?>
	</div>
	<div class="yui-u">   
         <div class="comment-meta commentmetadata"><a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s at %2$s'), get_comment_date(),  get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)'),'  ','') ?></div>
   <?php if ($comment->comment_approved == '0') : ?>
         <em><?php _e('Your comment is awaiting moderation.') ?></em>
         <br />
      <?php endif; ?>
      <?php comment_text() ?>

      <div class="reply">
         <?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
      </div>
</div>
     </div>
<?php
        }


?>
